#!/usr/bin/env python
import sys;
import base64;
from suds import WebFault;
from suds.client import Client;
flux=Client('http://13cflux.net/FluxWS/Flux?wsdl');
params=flux.factory.create('ns1:parameter');

tas=len(sys.argv);
#print tas;
h=0;
k=0;
l=0;
input2=0;
output=0;
if (len(sys.argv) > 1 ):
 for i in range(1,len(sys.argv)):
  if (sys.argv[i]=="-h"):
   print "*** This version of 13CFLUX 2 is licensed to:\n*** Demo Version, FZ Juelich\nStoichiometry Sampler (c) 2010 Michael Weitzel\nSyntax: ssampler <parameters>\n  -i/--in <file>        FluxML input file (stdin if omitted)\n  -o/--out <file>       HDF5 output file containing samples\n  -n/--nsamples <num>   number of samples (1000 if omitted)\n  -s/--sample [nx]      sampling targets: net fluxes, xch fluxes, or both\n  -S/--sampler [gh]     sampling method; g := Gibbs (default), h := Hit & Run\n  -b/--bound-net <num>  bound for the magnitude of unbounded NET fluxes\n  -p/--bound-xch <num>  bound for the magnitude of unbounded XCH fluxes\n  -f/--faster           sample faster but possibly less uniformly distributed\n  -r/--randomize <num>  randomization interval (default: 0=disabled)"

   h=1
 if (h==0):
  for i in range(1,len(sys.argv)):	
   if (sys.argv[i]=="-i"):
    input2=sys.argv[i+1]
    k=1;
   if (sys.argv[i]=="-o"):
    output=sys.argv[i+1]
    l=1;
   if (sys.argv[i]=="-n"):
    params.ssampler.nsamples=int(sys.argv[i+1]);
   if (sys.argv[i]=="-s"):
    params.ssampler.sample=sys.argv[i+1];
   if (sys.argv[i]=="-S"):
    params.ssampler.sampler=sys.argv[i+1];
   if (sys.argv[i]=="-p"):
    params.ssampler.bound_xch=float(sys.argv[i+1]);
   if (sys.argv[i]=="-b"):
    params.ssampler.bound_net=float(sys.argv[i+1]);
   if (sys.argv[i]=="-f"):
    params.ssampler.faster=True;
   if (sys.argv[i]=="-r"):
    params.ssampler.randomize=int(sys.argv[i+1]);



  if (k==1):
   if (l==1):
    fml_f = open(input2, 'rb');
    fml   = base64.b64encode(fml_f.read());
    fml_f.close();
    try:
     res=flux.service.SSampler(fml,params);
    except WebFault, e:
    	print 'Failed to invoke web service:';
    	print e.fault.faultstring;
    	exit(1);
    p=open(output, 'wb')
    p.write(base64.b64decode(res))
    p.close()
   if (l==0): 
    print "You have to specify an output file [-o FILENAME]"
  if (k==0):
   print "You have to specify an input file"
else:
 print "You have to specify an input file"
